// Convert.cpp : implementation file
//

#include "stdafx.h"
#include <fstream.h>
#include "fphn_cnv.h"
#include "Convert.h"
#include "fphn_cnvdlg.h"

extern CFphn_cnvDlg* pMainDlg;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConvert dialog


CConvert::CConvert(CWnd* pParent /*=NULL*/)
	: CDialog(CConvert::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConvert)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CConvert::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConvert)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConvert, CDialog)
	//{{AFX_MSG_MAP(CConvert)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConvert message handlers

BOOL CConvert::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	lxmax=pMainDlg->x_max;
	lymax=pMainDlg->y_max;
	
	//Initialize device context
	pDC=new CClientDC(this);

	GetDlgItem(IDC_CONV_CHAR)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	
	//Initialize colors, pens, brushes
	
	clr1=RGB(255,255,255);
	clr3=RGB(0,0,255);

	pPen1=new CPen(PS_SOLID,1,clr1);
	pBrush1=new CBrush(clr1);

	pPen2=new CPen(PS_SOLID,1,clr3);
	pBrush2=new CBrush(clr3);

	//Initialize font
	strcpy(logfont.lfFaceName,pMainDlg->fn);
	logfont.lfHeight=pMainDlg->ifs;
	logfont.lfWidth=0;
	logfont.lfEscapement=0;
	logfont.lfOrientation=0;
	if (pMainDlg->fst_bold) logfont.lfWeight=FW_BOLD;
	else logfont.lfWeight=FW_NORMAL;
	logfont.lfItalic=pMainDlg->fst_italic;
	logfont.lfUnderline=0;
	logfont.lfStrikeOut=0;
	logfont.lfCharSet=ANSI_CHARSET;
	logfont.lfOutPrecision=OUT_DEFAULT_PRECIS;
	logfont.lfClipPrecision=CLIP_DEFAULT_PRECIS;
	logfont.lfQuality=PROOF_QUALITY;
	logfont.lfPitchAndFamily=VARIABLE_PITCH | FF_ROMAN;

	font.CreateFontIndirect(&logfont);
	oldfont=pDC->SelectObject(&font);
	
	pDC->SetTextColor(clr3);
	
	
	tim=pMainDlg->ins;
	
	status_of_timer=false;
	m_timer = SetTimer(1,100,NULL);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConvert::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString pat;
	CString fname;

	int x,y;
	unsigned int xx,yy;

	bool check;
	
	unsigned int jx1,jy1,jx2,jy2;

	ofstream out;
	
	if (!status_of_timer)
	{
		status_of_timer=true;

		//Draw white box	
		pDC->SelectObject(pPen1);
		pDC->SelectObject(pBrush1);
	
		pDC->Rectangle(rect.left,rect.top,rect.right,rect.bottom);

		//Draw pattern
		pat.Format("%c",tim);
		
		CSize size;
		size=pDC->GetTextExtent(pat);

		unsigned int ix=rect.right-rect.left+1;
		unsigned int iy=rect.bottom-rect.top+1;
		
		unsigned int ix1=rect.left+(ix-size.cx)/2;
		unsigned int iy1=rect.top+(iy-size.cy)/2;
		
		pDC->TextOut(ix1,iy1,pat);
		
		//Scanning dimensions
		check=false;
		jx1=0;
		for (x=rect.left; x<=rect.right; x++)
		{
			for (y=rect.top; y<=rect.bottom; y++)
			{
				if (pDC->GetPixel(x,y)==clr3) 
				{
					check=true;
					break;
				}
			}

			if (check) 
			{
				jx1=x;
				break;
			}
		}
		if (!check) goto cant;
		
		jy1=0;
		check=false;
		for (y=rect.top; y<=rect.bottom; y++)
		{
			for (x=rect.left; x<=rect.right; x++)
			{
				if (pDC->GetPixel(x,y)==clr3) 
				{
					check=true;
					break;
				}
			}
				
			if (check) 
			{
				jy1=y;
				break;
			}
		}
		if (!check) goto cant;
		
		jx2=jx1+lxmax;
		jy2=jy1+lymax;

		//Converting...
		fname.Format("%02X",tim-(pMainDlg->ins));
		fname=(pMainDlg->fil)+fname+".pat";

		out.open(fname);
		if (out!=NULL)
		{
			out << lxmax+1 << '\n';
			out << lymax+1 << '\n';
			out << '\n';
			
			for (yy=jy1; yy<=jy2; yy++)
			{
				for (xx=jx1; xx<=jx2; xx++)
				{
					if (pDC->GetPixel(xx,yy)==clr3)
					{
						pDC->SetPixel(xx,yy,clr1);
						out << "O";
					}
					else
					{
						pDC->SetPixel(xx,yy,clr3);
						out << ".";
					}
				}
				out << '\n';
			}
		
			out.close();
		}
		else
		{
			AfxMessageBox("Can't open file for writing!",MB_OK);			
			OnCancel();
		}

cant:
		
		UpdateData(false);

		tim++;
		if (tim>pMainDlg->ine)
		{
			
			if (m_timer)
			{
				KillTimer(m_timer);
				m_timer = NULL;
			}

			OnOK();
		}

		status_of_timer=false;
	}

	
	CDialog::OnTimer(nIDEvent);
}
