//
// Class SCS_C_PRJ for configurations
//
// Copyright (C) 1998 by Grigori G.Fursin
//

//Import libraries...
import java.io.*;

public class SCS_C_PRJ
{
	//Variables
	private String NameOfFile=null;

	private int FilSMax;
	private int FilRMax;
	private int DirsMax;

	private String FilSa[];
	private String FilSb[];
	private String FilRa[];
	private String FilRb[];
	private String Dirs[];

	private int CurFilS;
	private int CurFilR;
	private int CurDirs;

	private String MainDir=null;
	private String FilesComp=null;
	private String OutFile=null;
	private boolean MPI;
	private int MPI_Proc;
	private int Period;

	private String CompileID;
	private String RunID;

	private boolean Saved;

	private boolean charR;

	String param[];
	int param_max=11;

	char FilSep='|';

	// *******************************************************************
	public SCS_C_PRJ(String xNameOfFile, int xFilSMax, int xFilRMax, int xDirsMax)
	{
		int i;

		setFilename(xNameOfFile);

		FilSMax=xFilSMax;
		FilRMax=xFilRMax;
		DirsMax=xDirsMax;

		FilSa=new String[FilSMax];
		FilSb=new String[FilSMax];
		FilRa=new String[FilRMax];
		FilRb=new String[FilRMax];
		Dirs=new String[DirsMax];

		for (i=0; i<FilSMax; i++) 
		{
			FilSa[i]="";
			FilSb[i]="";
		}
		for (i=0; i<FilSMax; i++) 
		{
			FilRa[i]="";
			FilRb[i]="";
		}

		clearDirs();

		CurFilS=0;
		CurFilR=0;

		setMainDir("");
		setFilesComp("");
		setOutFile("");
		setMPI(false);
		setMPI_Proc(1);
		setPeriod(5);
		setCompileID("");
		setRunID("");

		setSaved(false);

		charR=true;

		param=new String[param_max+1];

		 param[1]="Main_directory=";
		 param[2]="Files_to_compile=";
		 param[3]="Executive_name=";
		 param[4]="MPI_Library=";
		 param[5]="MPI_Processors=";
		 param[6]="Period=";
		 param[7]="Directories=";
		 param[8]="Files_to_be_sent=";
		 param[9]="Files_to_be_received=";
		param[10]="CompileID=";
		param[11]="RunID=";
	}

	// *******************************************************************
	public void setFilename(String xNameOfFile)
	{
		NameOfFile=xNameOfFile;
	}

	// *******************************************************************
	public String getFilename()
	{
		return NameOfFile;
	}

	// *******************************************************************
	public void setMainDir(String xMainDir)
	{
		if (!xMainDir.equals(MainDir))
		{
			MainDir=xMainDir;
			setSaved(false);
		}
	}

	// *******************************************************************
	public String getMainDir()
	{
		return MainDir;
	}

	// *******************************************************************
	public void setFilesComp(String xFilesComp)
	{
		if (!xFilesComp.equals(FilesComp))
		{
			FilesComp=xFilesComp;
			setSaved(false);
		}
	}

	// *******************************************************************
	public String getFilesComp()
	{
		return FilesComp;
	}

	// *******************************************************************
	public void setOutFile(String xOutFile)
	{
		if (!xOutFile.equals(OutFile))
		{
			OutFile=xOutFile;
			setSaved(false);
		}
	}

	// *******************************************************************
	public String getOutFile()
	{
		return OutFile;
	}

	// *******************************************************************
	public void setMPI(boolean xMPI)
	{
		if (xMPI!=MPI)
		{
			MPI=xMPI;
			setSaved(false);
		}
	}

	// *******************************************************************
	public boolean getMPI()
	{
		return MPI;
	}

	// *******************************************************************
	public void setMPI_Proc(int xMPI_Proc)
	{
		if (xMPI_Proc!=MPI_Proc)
		{
			if (xMPI_Proc<1) xMPI_Proc=1;

			MPI_Proc=xMPI_Proc;
			setSaved(false);
		}
	}

	// *******************************************************************
	public int getMPI_Proc()
	{
		return MPI_Proc;
	}

	// *******************************************************************
	public void setPeriod(int xPeriod)
	{
		if (xPeriod!=Period)
		{
			if (xPeriod<1) xPeriod=1;

			Period=xPeriod;
			setSaved(false);
		}
	}

	// *******************************************************************
	public int getPeriod()
	{
		return Period;
	}

	// *******************************************************************
	public void setCompileID(String xCompileID)
	{
		if (!xCompileID.equals(CompileID))
		{
			CompileID=xCompileID;
			setSaved(false);
		}
	}

	// *******************************************************************
	public String getCompileID()
	{
		return CompileID;
	}

	// *******************************************************************
	public void setRunID(String xRunID)
	{
		if (!xRunID.equals(RunID))
		{
			RunID=xRunID;
			setSaved(false);
		}
	}

	// *******************************************************************
	public String getRunID()
	{
		return RunID;
	}

	// *******************************************************************
	public void setSaved(boolean xSaved)
	{
		Saved=xSaved;
	}
	
	// *******************************************************************
	public boolean getSaved()
	{
		return Saved;
	}

	// *******************************************************************
	public int getDirsCur()
	{
		return CurDirs;
	}

	// *******************************************************************
	public int getFilSCur()
	{
		return CurFilS;
	}

	// *******************************************************************
	public int getFilRCur()
	{
		return CurFilR;
	}


	// *******************************************************************
	public boolean addDirs(String dir)
	{
		if (CurDirs>=DirsMax) return false;

		Dirs[CurDirs]=dir;
		CurDirs++;		

		setSaved(false);
		
		return true;
	}

	// *******************************************************************
	public String getDirs(int dir_index)
	{
		if ((dir_index>=CurDirs) || (dir_index<0)) return null;

		return Dirs[dir_index];
	}

	// *******************************************************************
	public void clearDirs()
	{
		for (int i=0; i<DirsMax; i++) Dirs[i]="";

		CurDirs=0;

		setSaved(false);
	}

	// *******************************************************************
	public int getDirsMax()
	{
		return DirsMax;
	}	

	// *******************************************************************
	public boolean addFilR(String a, String b)
	{
		if (CurFilR>=FilRMax) return false;

		FilRa[CurFilR]=a;
		FilRb[CurFilR]=b;
		CurFilR++;

		setSaved(false);
		
		return true;
	}

	// *******************************************************************
	public String getFilRa(int dir_index)
	{
		if ((dir_index>=CurFilR) || (dir_index<0)) return null;

		return FilRa[dir_index];
	}

	// *******************************************************************
	public String getFilRb(int dir_index)
	{
		if ((dir_index>=CurFilR) || (dir_index<0)) return null;

		return FilRb[dir_index];
	}

	// *******************************************************************
	public void clearFilR()
	{
		for (int i=0; i<FilRMax; i++) 
		{
			FilRa[i]="";
			FilRb[i]="";
		}

		CurFilR=0;

		setSaved(false);
	}

	// *******************************************************************
	public int getFilRMax()
	{
		return FilRMax;
	}	

	// *******************************************************************
	public boolean addFilS(String a, String b)
	{
		if (CurFilS>=FilSMax) return false;

		FilSa[CurFilS]=a;
		FilSb[CurFilS]=b;
		CurFilS++;
		
		setSaved(false);

		return true;
	}

	// *******************************************************************
	public String getFilSa(int dir_index)
	{
		if ((dir_index>=CurFilS) || (dir_index<0)) return null;

		return FilSa[dir_index];
	}

	// *******************************************************************
	public String getFilSb(int dir_index)
	{
		if ((dir_index>=CurFilS) || (dir_index<0)) return null;

		return FilSb[dir_index];
	}

	// *******************************************************************
	public void clearFilS()
	{
		for (int i=0; i<FilSMax; i++) 
		{
			FilSa[i]="";
			FilSb[i]="";
		}

		CurFilS=0;

		setSaved(false);
	}

	// *******************************************************************
	public int getFilSMax()
	{
		return FilSMax;
	}	

	// *******************************************************************
	public int Save()
	{
		String x;
		String y;
		int i;

		FileOutputStream fout=null;

		//***
		if (NameOfFile.equals("")) return 1;

		try
		{
			fout=new FileOutputStream(NameOfFile);
		}
		catch (IOException e1)
		{
			return 2;
		}

		x=param[1];
		y=getMainDir();
		if (!y.equals(""))
		{
			x+=y;
			if (!WriteLineOK(fout, x)) return 3;
		}

		x=param[2];
		y=getFilesComp();
		if (!y.equals(""))
		{
			x+=y;
			if (!WriteLineOK(fout, x)) return 3;
		}

		x=param[3];
		y=getOutFile();
		if (!y.equals(""))
		{
			x+=y;
			if (!WriteLineOK(fout, x)) return 3;
		}

		x=param[4];
		if (getMPI()) y="1"; else y="0";
		x+=y;
		if (!WriteLineOK(fout, x)) return 3;

		x=param[5];
		x+=String.valueOf(getMPI_Proc());
		if (!WriteLineOK(fout, x)) return 3;

		x=param[6];
		x+=String.valueOf(getPeriod());
		if (!WriteLineOK(fout, x)) return 3;

		if (CurDirs>0)
		{
			x=param[7];

			for (i=0; i<CurDirs; i++)
				if (!WriteLineOK(fout, x+getDirs(i))) return 3;
		}

		if (CurFilS>0)
		{
			x=param[8];

			for (i=0; i<CurFilS; i++)
				if (!WriteLineOK(fout, x+getFilSa(i)+FilSep+getFilSb(i))) return 3;
		}

		if (CurFilR>0)
		{
			x=param[9];

			for (i=0; i<CurFilR; i++)
				if (!WriteLineOK(fout, x+getFilRa(i)+FilSep+getFilRb(i))) return 3;
		}

		x=param[10];
		x+=String.valueOf(getCompileID());
		if (!WriteLineOK(fout, x)) return 3;

		x=param[11];
		x+=String.valueOf(getRunID());
		if (!WriteLineOK(fout, x)) return 3;

		try
		{
			fout.close();
		}
		catch (Exception e2)
		{
			return 4;
		}               

		setSaved(true);

		return 0;
	}

	// *******************************************************************
	private boolean WriteLineOK(FileOutputStream fout, String str)
	{
		try
		{
			int jl=str.length();
			for (int j=0; j<jl; j++)
			{
				fout.write(str.charAt(j));
			}
			if (charR==true) fout.write('\r');
			fout.write('\n');
		}
		catch (Exception e1)
		{
			try
			{
				fout.close();
			}
			catch (Exception e2)
			{
			}
			return false;
		}

		return true;
	}

	// *******************************************************************
	public int Load()
	{
		String x;
		String y;
		String z;

		String eof="EOF";
		String str;

		int i;
		int j;
		int l;
		int jl;
		int jl0;
		int jl1;

		int p;
		boolean q;

		int dec;

		FileInputStream finp=null;

		//***
		if (NameOfFile.equals("")) return 1;

		try
		{
			finp=new FileInputStream(NameOfFile);
		}
		catch (IOException e1)
		{
			return 2;
		}

		charR=false;

		str="";

		while (str!=eof)
		{
			str=ReadLine(finp, eof);
			if (str==null) return 3;

			if (!str.equals(eof))
			{
				//Looking for parameter...
				l=str.length();

				x=str.toUpperCase();

				j=0;
				for (i=1; i<=param_max; i++)
				{
					y=param[i].toUpperCase();
					jl=y.length();
					if (l>=jl)
					{
						if (y.equals(x.substring(0,jl)))
						{
							j=i;
							break;
						}
					}
				}

				if (j==0) return 4; //Unknown parameter

				z=str.substring(param[j].length(), l);

				jl0=z.length();

				if (!z.equals(""))
				{
					if (j==1) setMainDir(z);
					else if (j==2) setFilesComp(z);
					else if (j==3) setOutFile(z);
					else if (j==4)
					{
						try {dec=Integer.decode(z).intValue();}
						catch (NumberFormatException nfe1) {dec=0;}
						p=dec;
						if (p==1) q=true; else q=false;
						setMPI(q);
					}
					else if (j==5)
					{
						try {dec=Integer.decode(z).intValue();}
						catch (NumberFormatException nfe2) {dec=0;}
						p=dec;
						setMPI_Proc(p);
					}
					else if (j==6)
					{
						try {dec=Integer.decode(z).intValue();}
						catch (NumberFormatException nfe3) {dec=0;}
						p=dec;
						setPeriod(p);
					}
					else if (j==7) addDirs(z);
					else if ((j==8) || (j==9))
					{
						jl1=z.indexOf(FilSep);
						if ((jl1==-1) || (jl1==0) || (jl1==jl0-1)) return 4;

						x=z.substring(0,jl1);
						y=z.substring(jl1+1, jl0);
						
						if (j==8) addFilS(x,y);
						else addFilR(x,y);
					}
					else if (j==10) setCompileID(z);
					else if (j==11) setRunID(z);
					else return 4;
				}
			}
		}

		try
		{
			finp.close();
		}
		catch (Exception e2)
		{
			return 5;
		}

		setSaved(true);
		return 0;
	}

	// *******************************************************************
	private String ReadLine(FileInputStream finp, String eof)
	{
		String str="";

		try
		{
			boolean x=true;
			while (x)
			{
				int c=finp.read();
				if (c==-1) 
				{
					str=eof;
					x=false;
				}
				else if (c=='\r') charR=true;
				else if (c=='\n') x=false;
				else str+=(char)c;
			}
		}
		catch (Exception e1)
		{
			try
			{
				finp.close();
			}
			catch (Exception e2)
			{}
			str=null;
		}

		return str;
	}
}
