// KillJob.cpp : implementation file
//

#include "stdafx.h"
#include "scs_s_r.h"
#include "KillJob.h"

#include "fggcfg.h"
extern CFGGCfg* fggcfg;

#include "WndDlg.h"
extern CWndDlg* pMainDlg;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKillJob dialog


CKillJob::CKillJob(CWnd* pParent /*=NULL*/)
	: CDialog(CKillJob::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKillJob)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CKillJob::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKillJob)
	DDX_Control(pDX, IDC_KILL_JOB, m_button_kill_job);
	DDX_Control(pDX, IDC_LIST1, m_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CKillJob, CDialog)
	//{{AFX_MSG_MAP(CKillJob)
	ON_BN_CLICKED(IDC_KILL_JOB, OnKillJob)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKillJob message handlers

void CKillJob::OnKillJob() 
{
	// TODO: Add your control notification handler code here
	CString str;
	CDatabase db;
	TCHAR szError[StrMaxLen];
	
	char str1[StrMaxLen];
	char str1a[StrMaxLen];

	unsigned int n_jobs;
	unsigned int i;
	unsigned long id_run;
	
	//Preparing
	strcpy(str1, "You are going to kill ");
	n_jobs=m_list.GetSelCount();
	ultoa(n_jobs, str1a, 10);
	strcat(str1, str1a);
	strcat(str1, " job(s)!\n");
	strcat(str1, "         Are you sure?");
	if (AfxMessageBox(str1, MB_YESNO)==IDNO) return;
	
	m_list.GetSelItems(MaxJobs, &IDs_selected[0]);
		
	for (i=0; i<n_jobs; i++)
	{
		id_run=IDs[IDs_selected[i]];

		if (IDs_started[IDs_selected[i]])
		{
			//Connecting to database 'Jobs' through ODBC
			try
			{
				//Open database
				if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
				{
					AfxMessageBox("Fatal Internal Error: Can't connect to database [E010]!");
					OnCancel();
				}

				strcpy(str1,"UPDATE Started "
							"SET Started.MUST_BE_TERMINATED=Yes "
							"WHERE Started.ID_RUN=");
		
				ultoa(id_run, str1a, 10);
				strcat(str1, str1a);

				db.ExecuteSQL(_TEXT(str1));
				db.Close();
			}
			catch (CDBException *pEx)
			{
				str="Fatal Internal Error (while working with database) [E020]:\n";
				if (pEx->GetErrorMessage(szError, sizeof(szError)))
				{
					str+=szError;
				}
				AfxMessageBox(str);
				OnCancel();
			}
		}
		else
		{
			//Connecting to database 'Jobs' through ODBC
			try
			{
				//Open database
				if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
				{
					AfxMessageBox("Fatal Internal Error: Can't connect to database [E030]!");
					OnCancel();
				}

				strcpy(str1,"UPDATE Run "
							"SET Run.MAY_BE_KILLED=Yes "
							"WHERE Run.ID_RUN=");
		
				ultoa(id_run, str1a, 10);
				strcat(str1, str1a);

				db.ExecuteSQL(_TEXT(str1));
				db.Close();
			}
			catch (CDBException *pEx)
			{
				str="Fatal Internal Error (while working with database) [E040]:\n";
				if (pEx->GetErrorMessage(szError, sizeof(szError)))
				{
					str+=szError;
				}
				AfxMessageBox(str);
				OnCancel();
			}
		}
	}

	OnOK();
}

BOOL CKillJob::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_button_kill_job.EnableWindow(false);
	
	my_update();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CKillJob::my_update(void)
{
	CString str;
	CDatabase db;
	CRecordset fQuery(&db);
	CDBVariant varValue;

	TCHAR szError[StrMaxLen];
	
	char str1[StrMaxLen];
	char str1a[StrMaxLen];

	unsigned int i;

	//Preparing
	m_list.ResetContent();
	
	//Connecting to database 'Jobs' through ODBC
	try
	{
		//Open database
		if (!db.Open(_TEXT(fggcfg->Get(13)), FALSE, FALSE, _T("ODBC;"), FALSE))
		{
			AfxMessageBox("Fatal Internal Error: Can't connect to database [E050]!");
			OnCancel();
		}

		strcpy(str1, "SELECT Run.ID_RUN, Run.ID_USER, "
							"Run.FULLNAME, Run.MPI,  Run.PROCESSORS, "
							"Run.DATE_TIME_RECEIVED, Run.READY, "
							"Run.MAY_BE_KILLED, Accounts.FTP_ROOT_DIR "
					"FROM Accounts INNER JOIN Run ON Accounts.ID_USER=Run.ID_USER "
					"WHERE (((Run.READY)=No) AND ((Run.MAY_BE_KILLED)=No) AND ((Accounts.ACTIVE)=Yes)) "
					"ORDER BY Accounts.PRIORITY, Run.DATE_TIME_RECEIVED");
				
		if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
		{
			AfxMessageBox("Fatal Internal Error: Can't open Query to database [E060]!");
			goto _end_b;
		}

		if (!fQuery.IsEOF())
		{
			i=0;
			
			do
			{
				//ID_RUN
				fQuery.GetFieldValue((short) 0, varValue);
			
				if (varValue.m_dwType!=DBVT_LONG)
				{
							AfxMessageBox("Fatal Internal Error: Unknown type of 'ID_RUN' in database [E070]!");
_end_a:
							fQuery.Close();
_end_b:
							db.Close();

							OnCancel();
				}
			
				unsigned long id_run=varValue.m_lVal;

				IDs[i]=id_run;

				strcpy(str1, "SCS_S_R ID=");
				ultoa(id_run, str1a, 10);
				strcat(str1, str1a);

				//Checking if already started
				IDs_started[i]=false;
				int ret=pMainDlg->OnTimer0_JobsInQueueStarted(id_run);
				if (ret<0) goto _end_a;
				if (ret) 
				{
					IDs_started[i]=true;
					strcat(str1, " (started)");
				}
	
				m_list.AddString(str1);			
				
				fQuery.MoveNext();

				i++;
			}
			while ((i<MaxJobs)&&!fQuery.IsEOF());
		}
		fQuery.Close();
	
		db.Close();
	}
	catch (CDBException *pEx)
	{
		str="Fatal Internal Error (while working with database) [E080]:\n";
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			str+=szError;
		}
		AfxMessageBox(str);
		OnCancel();
	}
	
	UpdateData(false);
}

void CKillJob::OnSelchangeList1() 
{
	// TODO: Add your control notification handler code here
	if (m_list.GetSelCount()!=0) m_button_kill_job.EnableWindow(true);
	else m_button_kill_job.EnableWindow(false);
}
