// Wnddlg.h : header file
//

// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

/*****************************************************************************
  Development Team:
    Mary Kirtland
  Ported to 32-bit by:
    Mike Hedley	
  Created by Microsoft Product Support Services, Premier ISV Support
  Copyright (c) 1997 Microsoft Corporation. All rights reserved.
\****************************************************************************/

#ifndef __WNDDLG_H__
#define __WNDDLG_H__         
	
#include "mdlsmain.h"
	
#include <afxdb.h>

class CWndDlg : public CModelessMain
{
// Construction
public:
	CWndDlg();
	void SaveCFG(void);
	BOOL Create();
	void SetFound(bool x) {found=x;};
	bool GetFound(void) {return found;};
	void SetMyThread(DWORD mythread) {my_thread=mythread;};
	DWORD GetMyThread(void) {return my_thread;};
	void SetWnd(HWND x) {hwnd_found=x;}
	HWND GetWnd(void) {return hwnd_found;};
	int OnTimer0_JobsInQueueStarted(unsigned long id_run);
	int OnTimer0_KillStarted(unsigned long id_run);
private:
	CClientDC *pDC;

	CPen *pMyPen1;
	CBrush *pMyBrush1;
	CPen *pMyPen2;
	CBrush *pMyBrush2;
	CPen *pMyPen3;

	CPen *pMyPen5;
	CBrush *pMyBrush5;
	CPen *pMyPen6;
	CBrush *pMyBrush6;
	CPen *pMyPen7;
	CBrush *pMyBrush7;
	CPen *pMyPen8;
	CBrush *pMyBrush8;

	unsigned int ix1;
	unsigned int iy1;
	unsigned int ix2;
	unsigned int iy2;
	unsigned int ir1;
	unsigned int ir2;

	CRect rect1, rect2, rect5;

	unsigned int tim_max;
	unsigned int tim;

	unsigned int tim1_max;
	unsigned int tim1;
	
	bool status_of_timer;
	bool status_of_timer1;

	bool jobs_timer;
	bool working;
	bool suspended;

	unsigned int imax;
	unsigned int icur;
	unsigned int *sys_load;

	unsigned long jobs;
	unsigned long jobs_started;
	unsigned long processes;

	bool found;
	DWORD my_thread;
	HWND hwnd_found;
	
	//Functions...
	void init(void);
	void my_close(void);

	void OnTimer0(unsigned int pmax);
	void OnTimer1(unsigned int pmax);

	int OnTimer0_JobsInQueue(void);
	int OnTimer0_DBStart(unsigned long id_run);
	int OnTimer0_DBReady(unsigned long id_run);
	int OnTimer0_Success(unsigned long id_run, DWORD thr, DWORD prc);
	int SaveRes(unsigned long id_run, char *str);
	bool OnTimer0_Finished(unsigned long thr);
	bool OnTimer0_TimeOut(unsigned long time_started);
	void OnTimer0_Update_j_p(void);
	void OnTimer0_RealKill(unsigned long id_run, unsigned long prc, unsigned long thr);

	void DrawIdle(void);
	void DrawReq(void);
	void DrawClear(void);

	void DrawLoadClear(void);
	void DrawLoadLines(void);
	void DrawLoad(bool param);

protected:
	UINT m_timer;
	UINT m_timer1;

// Dialog Data 
protected:
	//{{AFX_DATA(CWndDlg)
	enum { IDD = IDR_MAIN };
	CStatic	m_st5;
	CStatic	m_st4;
	CStatic	m_st3;
	CStatic	m_st2;
	CStatic	m_st1;
	//}}AFX_DATA
	
// Overrides
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support  
	virtual BOOL OnInitDialog();

// Implementation
protected:          
	// Generated message map functions
	//{{AFX_MSG(CWndDlg)
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnStartServer();
	afx_msg void OnStopServer();
	afx_msg void OnUpdateStartServer(CCmdUI* pCmdUI);
	afx_msg void OnUpdateStopServer(CCmdUI* pCmdUI);
	afx_msg void OnAbout();
	afx_msg void OnExit();
	afx_msg void OnOptionsServer();
	afx_msg void OnOptionsWindow();
	afx_msg void OnUpdateAbout(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsServer(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsWindow(CCmdUI* pCmdUI);
	afx_msg void OnKillJob();
	afx_msg void OnUpdateKillJob(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
                     
#endif //__WND_H__
                     
