#include "windows.h"
#include "packets.h"
#include "processinfo.h"
#include "infoprint.h"
#include "mpirun.h"
#include "MPIServePacket.h"
#include "mpiserve.h"
#include "SocketReadAndWrite.h"
#include "crtdbg.h"

extern BOOL fExecutableSpecified;
extern BOOL fDebug;
extern DWORD dwNumProcs;
extern DWORD dwMyMachineID;
extern BOOL fWait;
extern WORD wPortNumber;
extern char szExecutable[MAXPATHLEN];
extern char szConfigFile[MAXPATHLEN];

DWORD RunRemoteMPIJob(JOBINFO *MemJI,WORLDPROCESSMAP *MemWPM)
{
	DWORD dwStatus = ERROR_SUCCESS;
	int i;
	int nNumBytes;
	int nServerFunction = MPI_SERVE_START_MPI_JOB;
	SOCKET s[MAX_NUM_MACHINES];
	SOCKADDR_IN aAddress;
	struct hostent *pheEnt;
	MPIServeStartMPIJobPacket_T JobPacket;
	MPIServeStartMPIJobReturnDataPacket_T ReturnPacket;

	ZeroMemory(&ReturnPacket,sizeof(MPIServeStartMPIJobReturnDataPacket_T));
	if (0 == wPortNumber)
		dwStatus = (DWORD)GetPortNumber(&wPortNumber);
	if (ERROR_SUCCESS == dwStatus)
	{
		JobPacket.fBlocking = fWait;
		JobPacket.MPIPortNumber = wPortNumber;
		memcpy(&JobPacket.JobInfo,MemJI,sizeof(JOBINFO));
		memcpy(&JobPacket.WorldProcessMap,MemWPM,sizeof(WORLDPROCESSMAP));
		for (i=0; i < (int)MemJI->dwNumMachines; i++)
		{
			JobPacket.dwMyMachineID = JobPacket.JobInfo.dwMyMachineID = i;
			pheEnt = gethostbyname(MemJI->Machine[i].szMachineName);
			if (NULL == pheEnt)
				goto cleanup;
			aAddress.sin_port = htons(wPortNumber);
			aAddress.sin_family = AF_INET;
			memcpy(&aAddress.sin_addr,pheEnt->h_addr,pheEnt->h_length);
			s[i] = socket(pheEnt->h_addrtype,SOCK_STREAM,0);
			if (INVALID_SOCKET == s[i])
				goto cleanup;
			dwStatus = (DWORD)connect(s[i],(PSOCKADDR)&aAddress,sizeof(SOCKADDR_IN));
			if (SOCKET_ERROR == dwStatus)
				goto cleanup;
			nNumBytes = SendSocketN(s[i],(BYTE*)&nServerFunction,sizeof(int));
			if (SOCKET_ERROR == nNumBytes)
				goto cleanup;
			nNumBytes = SendSocketN(s[i],(BYTE*)&JobPacket,sizeof(MPIServeStartMPIJobPacket_T));
			if (SOCKET_ERROR == nNumBytes)
				goto cleanup;
		}
		for (i=0; i < (int)MemJI->dwNumMachines; i++)
		{
			int j;
			nNumBytes = RecvSocketN(s[i],(BYTE*)&ReturnPacket,sizeof(MPIServeStartMPIJobReturnDataPacket_T));
			if (SOCKET_ERROR == nNumBytes)
				goto cleanup;
			printf("[%d] Processes from machine [%d] [%s]\n",MemJI->Machine[i].dwNumProcesses,i,MemJI->Machine[i].szMachineName);
			printf("\tThe status of the request was [%x]\n",ReturnPacket.dwStatus);
			for (j=0; j < (int)MemJI->Machine[i].dwNumProcesses;j++)
			{
				printf("\t\tThe exit status of process [%d] was (if waited on) [%x]\n",
								j,ReturnPacket.dwExitCodes[j]);
			}
		}
	}
	else
		printf("Error getting port number of service!\n");

cleanup:
	dwStatus = WSAGetLastError();
	return dwStatus;
}