//  MODULE:   MPIServeQueryInfo.c
//
//  PURPOSE:	Function to Query the status of the Service
//				(not yet defined)
//
//  FUNCTIONS:
//
//		DWORD WINAPI MPIServeQueryInfo(LPVOID lpV)
//
//  COMMENTS:
//
//  AUTHOR: Shane Hebert
//


#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <tchar.h>
#include <winsock.h>
#include "service.h"
#include "processinfo.h"
#include "mpiserve.h"
#include "SocketReadAndWrite.h"
#include "MPIServePacket.h"

DWORD WINAPI MPIServeQueryInfo(LPVOID lpV)
{
	DWORD dwStatus = ERROR_SUCCESS;
	SOCKET sSocket = (SOCKET)lpV;
	MPIServeQueryInfoPacket_T InfoPacket;
	MPIServeQueryReturnInfoPacket_T ReturnPacket;

	dwStatus = RecvSocketN(sSocket,(BYTE*)&InfoPacket,sizeof(MPIServeQueryInfoPacket_T));
	if (SOCKET_ERROR == dwStatus)
		goto reporterror;

cleanup:
	ReturnPacket.dwDummy = dwStatus;
	SendSocketN(sSocket,(BYTE*)&ReturnPacket,sizeof(MPIServeQueryReturnInfoPacket_T));
	closesocket(sSocket);
	return dwStatus;
reporterror:
	dwStatus = WSAGetLastError();
	goto cleanup;
}
